"use strict"; // Module for loading the protobuf description from serialized description

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseConfigure = parseConfigure;

var ProtoBuf = _interopRequireWildcard(require("protobufjs-old-fixed-webpack"));

var _messages = require("./messages.js");

var _to_json = require("./to_json.js");

var compiledConfigProto = _interopRequireWildcard(require("./config_proto_compiled.js"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

// Parse configure data (it has to be already verified)
function parseConfigure(data) {
  // incoming data are in JSON format
  if (data.match(/^\{.*\}$/)) {
    var _protobufMessages = ProtoBuf.newBuilder({})["import"](JSON.parse(data)).build();

    return new _messages.Messages(_protobufMessages);
  } // incoming data are in binary format


  var buffer = Buffer.from(data.slice(64 * 2), "hex");
  var configBuilder = compiledConfigProto["Configuration"];
  var loadedConfig = configBuilder.decode(buffer);
  var validUntil = loadedConfig.valid_until;
  var timeNow = Math.floor(Date.now() / 1000);

  if (timeNow >= validUntil) {
    throw new Error("Config too old; " + timeNow + " >= " + validUntil);
  }

  var wireProtocol = loadedConfig.wire_protocol;
  var protocolJSON = (0, _to_json.protocolToJSON)(wireProtocol.toRaw());
  var protobufMessages = ProtoBuf.newBuilder({})["import"](protocolJSON).build();
  return new _messages.Messages(protobufMessages);
}